{$A+,B-,D+,E+,F-,G+,I-,L+,N+,P-,Q-,R-,S-,T-,V+,X+,Y+}

{MULTITASK-DEMO
 

(C) '95 by A. von Wyss
Alle Rechte vorbehalten}

program testmultitask;

uses crt,multitask;

type
	pscr=^tscr;
	tscr=array[0..199,0..319] of byte;

const
	depth=64;

var
	scr: pscr;

{PIXEL-Thread}
procedure pixel(var param); far;
var
	i: integer;
begin
	repeat
		for i:=1 to 100 do
			scr^[random(100)+100,random(160)]:=random(256);
		switch;
	until mem[seg0040:$0017] and 4>0;
end;

{APFELmnnchen-Thread}
function iter(x,y: single): byte;
var
	x1,y1,xq,yq: single;
	n: word;
begin
	x1:=sqr(x)+sqr(y);
	y1:=sqrt(x1-x/2+1/16);
	if (16*x1*y1<=5*y1-4*x+1) or (sqr(x+1)+sqr(y)<=1/16) then begin
		iter:=0;
		exit;
	end;
	n:=0;
	x1:=x;
	y1:=y;
	xq:=sqr(x);
	yq:=sqr(y);
	repeat
		y1:=2*x1*y1+y;
		x1:=xq-yq+x;
		xq:=sqr(x1);
		yq:=sqr(y1);
		inc(n);
	until (xq+yq>4) or (n=depth);
	if n=depth then
		iter:=0
	else
		iter:=n mod 24+32;
end;

procedure apfel(var param); far;
const
	steps=1150;
var
	xs,ys,xp,yp,startx: single;
	x,y: word;
	cnt: integer;
	col: byte;
begin
	repeat
		for cnt:=0 to steps-1 do begin
			xp:=-14.51+Sqrt(Cnt)/2.659852889034;
			startx:=xp;
			yp:=0;
			xs:=(25*(1-Sqrt(cnt)/Sqrt(steps)))/160;
			for y:=150 downto 100 do begin
				xp:=startx;
				for x:=160 to 319 do begin
					col:=iter(xp,yp);
					scr^[y,x]:=col;
					scr^[300-y,x]:=col;
					xp:=xp+xs;
				end;
				yp:=yp-xs;
				if mem[seg0040:$0017] and 8>0 then
					exit;
			end;
		end;
		delay(5000);
	until false;
end;

{CIRCLE-Thread, PSET ist fr das Clipping der Kreise}
procedure pset(x,y: integer; col: byte);
begin
	if (x>=0) and (y>=0) and (x<160) and (y<100) then
		scr^[y,x]:=col;
end;

procedure circle(var param); far;
var
	x1,y1,r,d,x,y,i,j,k: integer;
	col: byte;
begin
	repeat
		x1:=random(160);
		y1:=random(100);
		col:=32;
		for r:=1 to random(20) do begin
			d:=pred(r);
			x:=0;
			y:=r;
			inc(col);
			repeat
				if d<0 then begin
					dec(y);
					inc(d,y shl 1);
				end;
				pset(x1+x,y1+y,col);
				pset(x1-x,y1+y,col);
				pset(x1+x,y1-y,col);
				pset(x1-x,y1-y,col);
				pset(x1+y,y1+x,col);
				pset(x1-y,y1+x,col);
				pset(x1+y,y1-x,col);
				pset(x1-y,y1-x,col);
				dec(d,succ(x shl 1));
				inc(x);
			until x>y;
		end;
		switch;
	until mem[seg0040:$0017] and 2>0;
end;

{BOX-Thread}
procedure box(var param); far;
var
	x1,y1,x2,y2,i,j: integer;
	col: byte;
begin
	repeat
		for j:=1 to 10 do begin
			x1:=random(160)+160;
			y1:=random(100);
			x2:=x1+random(320-x1);
			y2:=y1+random(100-y1);
			col:=random(256);
			for i:=x1 to x2 do begin
				scr^[y1,i]:=col;
				scr^[y2,i]:=col;
			end;
			for i:=y1 to y2 do begin
				scr^[i,x1]:=col;
				scr^[i,x2]:=col;
			end;
		end;
		switch;
	until mem[seg0040:$0017] and 1>0;
end;

{CLRX-Thread}
procedure clrx(var param); far;
var
	x,y,i: integer;
begin
	repeat
		for x:=0 to 319 do begin
			forbid;
			for y:=0 to 99 do
				scr^[y,x]:=0;
			for i:=1 to 7 do
				for y:=0 to 99 do
					scr^[y,x+i]:=i+22;
			for i:=8 to 15 do
				for y:=0 to 99 do
					scr^[y,x+i]:=38-i;
			permit;
			switch;
		end;
	until false;
end;

{CLRY-Thread}
procedure clry(var param); far;
var
	y,i: integer;
begin
	repeat
		for y:=0 to 199 do begin
			forbid;
			fillchar(scr^[y,0],160,0);
			if y<=199-7 then
				for i:=1 to 7 do
					fillchar(scr^[y+i,0],160,i+22);
			if y<=199-15 then
				for i:=8 to 15 do
					fillchar(scr^[y+i,0],160,38-i);
			permit;
			switch;
		end;
	until false;
end;

procedure launch(var param); far;
begin
	newtask('Circle',16000,circle,nil);
	delay(1000);
	newtask('Box',16000,box,nil);
	delay(1000);
	newtask('Pixels',16000,pixel,nil);
	delay(1000);
	newtask('Apfelman',16000,apfel,nil);
	delay(1000);
	newtask('ClearX',16000,clrx,nil);
	delay(1000);
	newtask('ClearY',16000,clry,nil);
end;

{XREADKEY wartet auf eine Taste und gibt nicht bentigte Rechenzeit ab}
function xreadkey: char;
begin
	asm
		mov	es,[seg0040]	{BIOS-Segment}
	@loop:
		mov	bx,es:[$001A]	{Startadresse...}
		xor	bx,es:[$001C]	{XOR Endadresse: wenn 0 sind Zeichen im Puffer!}
		jne	@endasm			{Immer nocht nichts?}
		call	[switch]			{Rechenzeit abgeben}
		jmp	@loop
	@endasm:
	end;
	xreadkey:=readkey;		{Zeichen einlesen}
end;

begin
	scr:=ptr(segA000,0);
	clrscr;
	writeln('Threads');
	writeln('');
	writeln;
	writeln('Threads sind Multitaskingproceduren. Das heisst, das sie parallel zum Haupt-');
	writeln('programm weiterlaufen, ohne dieses zu beeinflussen. Die Threads werden alle');
	writeln('mit gleich viel Rechenzeit versorgt. Natrlich wird die Ausfhrung der');
	writeln('Threads langsamer, wenn viele installiert werden; sie knnen jedoch ihre');
	writeln('Rechenzeit abgeben, wenn sie im Stillstand sind.');
	writeln('Das Programm startet einen Thread, der die anderen ausfhrt. Whrenddessen');
	writeln('wartet das Programm schon auf eine Taste, um sich zu beenden. Der Starter');
	writeln('erzeugt 6 neue Threads. Also laufen 8 und spter 7 vllig unabhngige Programm-');
	writeln('teile weiter, ohne sich gegenseitig zu stren. Der Starter startet alle fnf');
	writeln('Sekunden einen neuen Thread, bis er 6 erstellt hat. Dann beendet er sich.');
	writeln;
	writeln('Mit LSHIFT kann der Kreisthread beendet werden.');
	writeln('Mit RSHIFT kann der Rechteckthread beendet werden.');
	writeln('Mit CONTROL kann der Punktethread beendet werden.');
	writeln('Mit ALT kann der Farbbalkenthread beendet werden.');
	writeln('Die "grauen Balken"-Threads knnen nicht beendet werden.');
	writeln('Die beendeten Threads knnen nicht wieder gestartet werden.');
	writeln;
	writeln('Taste zum Starten...');
	directvideo:=false;
	xreadkey;
	asm
		mov	ax,$13 {320*200*256-Videomodus}
		int	$10
	end;
	newtask('Launcher',16000,launch,nil);
	xreadkey;
	forbid; {Bildschirmspeicher ist gleich nicht mehr verfgbar!!!}
	textmode(co80);
end.
